

//  (C) Copyright Boost.org 2001. Permission to copy, use, modify, sell and
//  distribute this software is granted provided this copyright notice appears
//  in all copies. This software is provided "as is" without express or implied
//  warranty, and with no claim as to its suitability for any purpose.

//  See http://www.boost.org for most recent version.

/* 
 * @$Id: dinkumware.h,v 1.1 2003/11/24 12:18:05 kleanthis Exp $ 
 */

//  Dinkumware standard library config:

#if !defined(_YVALS) && !defined(_CPPLIB_VER)
#include <utility>
#if !defined(_YVALS) && !defined(_CPPLIB_VER)
#error This is not the Dinkumware lib!
#endif
#endif


#if defined(_CPPLIB_VER) && (_CPPLIB_VER >= 306)
   // full dinkumware 3.06 and above
   // fully conforming provided the compiler supports it:
#  if !(defined(_GLOBAL_USING) && (_GLOBAL_USING+0 > 0)) && !defined(_STD)   // can be defined in yvals.h
#     define AMBULANT_NO_STDC_NAMESPACE
#  endif
#  if !(defined(_HAS_MEMBER_TEMPLATES_REBIND) && (_HAS_MEMBER_TEMPLATES_REBIND+0 > 0)) && !(defined(_MSC_VER) && (_MSC_VER > 1300)) && defined(AMBULANT_MSVC)
#     define AMBULANT_NO_STD_ALLOCATOR
#  endif
#  if defined(_MSC_VER) && (_MSC_VER < 1300)
      // if this lib version is set up for vc6 then there is no std::use_facet:
#     define AMBULANT_NO_STD_USE_FACET
#     define AMBULANT_HAS_TWO_ARG_USE_FACET
      // C lib functions aren't in namespace std either:
#     define AMBULANT_NO_STDC_NAMESPACE
      // and nor is <exception>
#     define AMBULANT_NO_EXCEPTION_STD_NAMESPACE
#  endif
// There's no numeric_limits<long long> support unless _LONGLONG is defined:
#  if !defined(_LONGLONG) && (_CPPLIB_VER <= 310)
#     define AMBULANT_NO_MS_INT64_NUMERIC_LIMITS
#  endif
// 3.06 appears to have (non-sgi versions of) <hash_set> & <hash_map>, 
// and no <slist> at all
#else
#  define AMBULANT_MSVC_STD_ITERATOR 1
#  define AMBULANT_NO_STD_ITERATOR
#  define AMBULANT_NO_TEMPLATED_ITERATOR_CONSTRUCTORS
#  define AMBULANT_NO_STD_ALLOCATOR
#  define AMBULANT_NO_STDC_NAMESPACE
#  define AMBULANT_NO_STD_USE_FACET
#  define AMBULANT_NO_STD_OUTPUT_ITERATOR_ASSIGN
#  define AMBULANT_HAS_MACRO_USE_FACET
#  ifndef _CPPLIB_VER
      // Updated Dinkum library defines this, and provides
      // its own min and max definitions.
#     define AMBULANT_NO_STD_MIN_MAX
#     define AMBULANT_NO_MS_INT64_NUMERIC_LIMITS
#  endif
#endif

#if (defined(_MSC_VER) && (_MSC_VER <= 1300)) || !defined(_CPPLIB_VER) || (_CPPLIB_VER < 306)
   // if we're using a dinkum lib that's
   // been configured for VC6/7 then there is
   // no iterator traits (true even for icl)
#  define AMBULANT_NO_STD_ITERATOR_TRAITS
#endif

#if defined(__ICL) && defined(_CPPLIB_VER) && (_CPPLIB_VER <= 310)
// Intel C++ chokes over any non-trivial use of <locale>
// this may be an overly restrictive define, but regex fails without it:
#  define AMBULANT_NO_STD_LOCALE
#endif

#ifdef _CPPLIB_VER
#  define AMBULANT_DINKUMWARE_STDLIB _CPPLIB_VER
#else
#  define AMBULANT_DINKUMWARE_STDLIB 1
#endif

#ifdef _CPPLIB_VER
#  define AMBULANT_STDLIB "Dinkumware standard library version " AMBULANT_STRINGIZE(_CPPLIB_VER)
#else
#  define AMBULANT_STDLIB "Dinkumware standard library version 1.x"
#endif







